/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.lokalisierung.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class LokalisierungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale locale;
    public de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale getLocale(){
      return locale;
    }
    protected final java.lang.String schluessel;
    public java.lang.String getSchluessel(){
      return schluessel;
    }

  public LokalisierungTK(
de.ivu.elect.business.lokalisierung.entity.LokalisierungLocale locale
, java.lang.String schluessel
  ) {
    super();


      this.locale = locale;
      this.schluessel = schluessel;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((locale == null) ? 0 : locale.hashCode());
                    result = result + ((schluessel == null) ? 0 : schluessel.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof LokalisierungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        LokalisierungTK other = (LokalisierungTK) obj;

                if (locale == null) {
          if (other.locale != null) {
            return false;
          }
        } else if (!locale.equals(other.locale)) {
          return false;
        }
                if (schluessel == null) {
          if (other.schluessel != null) {
            return false;
          }
        } else if (!schluessel.equals(other.schluessel)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL, LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL, locale));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(LokalisierungConstants.MESSAGE_KEY_ENTITY_EINZAHL, LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, schluessel));
        
        return result;
      }


            @Override
            public String toString() {
            return "LokalisierungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"locale="+locale
                            +", schluessel="+schluessel
                        
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    + messages.getMessageForMessageKey(LokalisierungConstants.MESSAGE_KEY_LOCALE_EINZAHL) + "=" + locale
    + ", " + messages.getMessageForMessageKey(LokalisierungConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL) + "=" + schluessel
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Lokalisierung> java.util.Map<LokalisierungTK, E> mappeLokalisierungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Lokalisierung::getLokalisierungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Lokalisierung, LokalisierungTK> getLokalisierungToTKFunction() {
                return Lokalisierung::getLokalisierungTK;
                }

}
